#lang racket/base

(require "api.rkt")

(provide test-soa-rr test-rrs test-roots)

(define test-soa-rr
  (rr '(#"example") 'soa 'in 30
      (soa '(#"ns" #"example")
	   '(#"tonyg" #"example")
	   1
	   24
	   24
	   30
	   10)))

(define test-rrs
  (list (rr '(#"localhost" #"example") 'a 'in 30 '#(127 0 0 1))
	(rr '(#"example") 'mx 'in 30 (mx 5 '(#"localhost" #"example")))
	(rr '(#"example") 'mx 'in 30 (mx 10 '(#"subns" #"example")))
	(rr '(#"google" #"example") 'cname 'in 30 '(#"www" #"google" #"com"))
	(rr '(#"roar" #"example") 'a 'in 30 '#(192 168 1 1))
	(rr '(#"alias" #"example") 'cname 'in 30 '(#"roar" #"example"))
	(rr '(#"ns" #"example") 'a 'in 30 '#(127 0 0 1))
	(rr '(#"hello" #"example") 'txt 'in 30 '(#"Hello CRASH"))
	(rr '(#"subzone" #"example") 'ns 'in 30 '(#"subns" #"example"))
	(rr '(#"subns" #"example") 'a 'in 30 '#(127 0 0 2))))

(define test-roots
  (list (rr '() 'ns 'in 30 '(#"f" #"root-servers" #"net"))
	(rr '(#"f" #"root-servers" #"net") 'a 'in 30 '#(198 41 0 4))
	(rr '(#"f" #"root-servers" #"net") 'a 'in 30 '#(192 228 79 201))
	(rr '(#"f" #"root-servers" #"net") 'a 'in 30 '#(192 33 4 12))
	(rr '(#"f" #"root-servers" #"net") 'a 'in 30 '#(192 203 230 10))
	(rr '(#"f" #"root-servers" #"net") 'a 'in 30 '#(192 112 36 4))
	(rr '(#"f" #"root-servers" #"net") 'a 'in 30 '#(128 63 2 53))
	(rr '(#"f" #"root-servers" #"net") 'a 'in 30 '#(192 58 128 30))
	(rr '(#"f" #"root-servers" #"net") 'a 'in 30 '#(193 0 14 129))))
